Attribute VB_Name = "modPropList"



Public CaptionWidth As Long
Public plItemCount As Long

Public capList() As String
Public txtList() As txtEdit

Public Type txtEdit
  SelStart As Long
  SelText As String
  SelLength As Long
  Text As String
End Type

Public Type ItemInfo
  Text As txtEdit
  'Type As plPropType
  Caption As String
  Index As Long
End Type

Public PropItems() As ItemInfo
Public SelectedItem As ItemInfo

Public pColIndexNums() As Long
Public pColIndexNumsCount As Long

Public Function GetPropListTypeText(pl As plPropType) As String
Dim cType As String

Select Case pl
  Case 0 'Text
    cType = "text"
  Case 1 'Boolean
    cType = "boolean"
  Case 2 'Combo
    cType = "combo"
  Case 3 'Browse
    cType = "browse"
  Case 4 'Color
    cType = "color"
  Case 5 'Font
    cType = "font"
  Case 6 'Form
    cType = "form"
End Select

GetPropListTypeText = cType
End Function

Public Function GetPropListType(plTxt As String) As plPropType
Dim cType As plPropType

Select Case plTxt
  Case "text"
    cType = plText
  Case "boolean"
    cType = plBoolean
  Case "combo"
    cType = plCombo
  Case "browse"
    cType = plBrowse
  Case "color"
    cType = plColor
  Case "font"
    cType = plFont
  Case "form"
    cType = plForm
End Select

GetPropListType = cType
End Function

Public Sub PlaceCntrl(l As Label, _
           cdlg As CommonDialog, _
           txt As TextBox, _
           pCmb As PictureBox, _
           pCol As PictureBox, _
           cmb As OwnerDrawComboList, _
           brwse As CommandButton, _
           frmbtn As CommandButton, _
           cWidth As Long, _
           cVisLine As Integer, _
           cGridWidth As Long, _
           Optional frm As Form)
           
Dim cHeight As Long
Dim cTop As Long

pCmb.Visible = False
brwse.Visible = False
frmbtn.Visible = False

cHeight = l.Height
cTop = l.Top
cLeft = l.Width + txt.Width + cGridWidth
'Place the controls in the correct location...
Select Case LCase(l.Tag)
  Case "browse", "font"
    brwse.Height = cHeight + cGridWidth
    brwse.Move cLeft - brwse.Width, cTop + (cHeight / 2 - brwse.Height / 2)
    brwse.Visible = True
  Case "boolean", "combo", "color"
    'If it's color, then we need to adjust the left
    'b/c of the picturebox displaying the color...
    Dim cExtra As Long
    On Error Resume Next
    If LCase(l.Tag) = "color" Then
         cExtra = pCol.Width
       Else
         cExtra = 0
    End If
    cmb.Width = txt.Width
    cmb.Move -txt.Width + 275 - 15, -50
    pCmb.Width = 275 - 60
    pCmb.Move cLeft - pCmb.Width + cExtra, cTop - 30 + 15, pCmb.Width, cHeight + 30
    
    Call LoadComboList(cmb, txt.Tag, LCase(l.Tag))
    
    pCmb.Visible = True
End Select

End Sub

Public Function GetNumFields(FieldList As String) As Integer
Dim i As Long
Dim lstCount As Integer

     lstCount = 0
     'Count the # of ,'s are in the list...
     For i = 1 To Len(FieldList)
         i = InStr(i, FieldList, ",")
         'If there's no more, then exit!!
         If i = 0 Then
            Exit For
         End If
         
         'Add 1 to list...
         lstCount = lstCount + 1
     Next i
     
     GetNumFields = lstCount
End Function
Public Function FieldInString(ByVal StringArg As String, ByVal FieldNumber As Integer) As String

    ' This Function returns requested field # from str
    '     ing argument
    Dim X, Y, oldY As Integer
    'add a delimiting space to the end of the argument
    '
    StringArg = StringArg + " "
    X = 0
    Y = 1
    oldY = 1

    While Y < Len(StringArg) And X < FieldNumber
        Y = InStr(oldY, StringArg, ",")
        On Error Resume Next
        FieldInString = Mid$(StringArg, oldY, Y - oldY)
        X = X + 1
        oldY = Y + 1
    Wend

        'If requested field # was greater than the # of wo
        '     rds in
        'passed string argument, then return an empty stri
        '     ng

        If X < FieldNumber Then FieldInString = ""
 End Function
 
 Public Function RemoveFieldInString(ByVal StringArg As String, ByVal FieldNumber As Integer) As String

    ' This Function returns requested field # from str
    '     ing argument
    Dim X, Y, oldY As Integer
    Dim nPos As Integer
    Dim cTotal As String
    'add a delimiting space to the end of the argument
    '
    StringArg = StringArg + " "
    X = 0
    Y = 1
    oldY = 1
    cTotal = ""

    While Y < Len(StringArg) And X < FieldNumber - 1
        Y = InStr(oldY, StringArg, ",")
        On Error Resume Next
        'Gets all the text before the field...
        cTotal = cTotal & Mid$(StringArg, oldY, Y - oldY) & ","
        X = X + 1
        oldY = Y + 1
    Wend
    
    On Error Resume Next
    nPos = InStr(Len(cTotal) + 1, StringArg, ",")
    cNxt = Mid(StringArg, nPos)
    cTotal = cTotal & Mid(cNxt, 2)
    
    RemoveFieldInString = cTotal
 End Function

Public Sub LoadComboList(cmb As OwnerDrawComboList, cmbList As String, cmbType As String)
Dim numFields As Integer, i As Integer
'Get rid of any existing list...
cmb.Clear

If cmbType = "combo" Then
  'Set the style so it's text only...
  cmb.ClientDraw = ecdNoClientDraw
  'Get the # of fields (commas) in the list so we
  'load it based on the list...
  numFields = GetNumFields(cmbList)
  
  'Go through the list and add it to the combobox
  For i = 1 To numFields
    cmb.AddItem FieldInString(cmbList, i)
  Next i
  
  cmb.DropDownWidth = cmb.Width / Screen.TwipsPerPixelX
End If

If cmbType = "boolean" Then
   'Set the style so it's text only...
   cmb.ClientDraw = ecdNoClientDraw
   'Add the boolean items...
   cmb.AddItem "True"
   cmb.AddItem "False"
   
   cmb.DropDownWidth = cmb.Width / Screen.TwipsPerPixelX
End If

If cmbType = "color" Then
   'Set the style so it's text only...
   cmb.ClientDraw = ecdColourPickerWithNames
   With cmb
        .AddItemAndData "Black", , , , vbBlack
        .AddItemAndData "Dark Red", , , , &H80&
        .AddItemAndData "Dark Green", , , , &H8000&
        .AddItemAndData "Ochre", , , , &H8080&
        .AddItemAndData "Dark Blue", , , , &H800000
        .AddItemAndData "Purple", , , , &H800080
        .AddItemAndData "Turquoise", , , , &H808000
        .AddItemAndData "Silver", , , , &HC0C0C0
        .AddItemAndData "Gray", , , , &H808080
        .AddItemAndData "Red", , , , vbRed
        .AddItemAndData "Green", , , , vbGreen
        .AddItemAndData "Yellow", , , , vbYellow
        .AddItemAndData "Blue", , , , vbBlue
        .AddItemAndData "Magenta", , , , vbMagenta
        .AddItemAndData "Cyan", , , , vbCyan
        .AddItemAndData "White", , , , vbWhite
        .AddItemAndData "Custom...", , , , vbBlack
        
        .ItemOverLine(.ListCount - 1) = True
   End With
End If
End Sub
